# ++++++++++++++++++++++++++++++++++++++++++++
# Generer les indices des polygones voisins dans une grille
# regulire de polygones: les voisins de J sont les polygones
# dans le carr form par nvois polygones autour de J.
#NOTE:  Les polygones sont numrots de la gche vers la dte,
# de bas en haut
# ++++++++++++++++++++++++++++++++++++++++++++
generVois <- function (np=10, nvois=1) {
  npoly <- np*np
  retour <- matrix(NA, ncol=2)
  for (j in 1:npoly) {
    # Les polys extrmes du voisinage en bas  gauche et  droite
    # Verifier que ces polys sont dans le cadre
    re <- j%%np
    # nbre de cases libres a gche et a dte de j
    if (re==0)
      {
        nlibresg <- np-1
        nlibresd <- 0
      }    else {
        nlibresg <- re-1
        nlibresd <- np-re
      }
    nvg <- min(nvois, nlibresg)
    nvd <- min(nvois, nlibresd)
    # Les polys extrmes du voisinage en bas  gauche
    # et  droite sont donc:
     bas <- c(j-(np*nvois)-nvg, j-(np*nvois) + nvd)

  # Generer tous les indices des carrs a partir de ceux-ci
    i<-1
    while( i <= ((nvois*2)+1)) {
      if (all(bas>npoly)) break
      while ( all(bas<=0)) {
        bas <- bas+np
        i<-i+1
        next
      }
        
      for (iv in bas[1]:bas[2])
        retour <- rbind(retour, c(j, iv))
      bas <- bas+np
    i<-i+1
    } # fin i
  } # fin j

    # Oter les polys hors cadre
      retour <- retour[retour[,2]>0,, drop=FALSE]
      retour <- retour[retour[,2]<=npoly, , drop=FALSE]
  return(retour[2:nrow(retour),,drop=FALSE])
} #fin generVois
  
      
      
                                    
