#source("init")
# Gnrer une grille de polygones:
np <- 3
# une grille de 3x3 carrs de 10m de ct:
g<-generPoly(file="grille3x3.data", np=np, step=10, plot=FALSE)


# Gnrer les voisins de chaque polygone:
# pour chaque polygone, on obtient les indices des polygones inclus
# dans le carr form par ses 1 plus proches voisins
poly <- generVois(np=np, nvois=1) 
# Comme tous les polys sont semblables, le flux est identique
# dans chacune des configurations: on peut se limiter  l'etude
# du carr central
poly <- matrix(poly[poly[,1]==5], ncol=2)
# Encore mieux: eliminer les configurations symtriques
# (flux en-dessus=flux au-dessus, flux a gauche=flux a droite, etc...)
poly <- matrix(c(rep(5,3), 1,2,5), ncol=2)
#NB: le calcul des flux entre carrs latraux demande
# d'accroitre maxpts, pour que la convergence soit atteinte.
# Donc, calculer entre carrs l'un au-dessus de l'autre
# de prfrence  carrs l'un  ct de l'autre
# (les flux sont les mmes)

# Cubature:
cub3x3.res <- califlopp(file="grille3x3.data",
                 param=list(verbose=FALSE,poly=poly,
 #                  maxpts=800000000,   
                   fun=1),
                 resfile="grille3x3.cub.res")


# Grid:
param <- list(method="grid", step=c(1,1), nr=10, output=1, poly=poly)
grid3x3.res <- califlopp(file="grille3x3.data",
                 param=param, resfile="grille3x3.grid.res")
