#source("init")
# Gnrer une grille de polygones:
np <- 6
# une grille de 6x6 carrs de 10m de ct:
g<-generPoly(file="grille6x6.data", np=np, step=10, plot=FALSE)


# Gnrer les voisins de chaque polygone:
# pour chaque polygone, on recherche les indices des polygones inclus
# dans le carr form par ses 2 plus proches voisins
poly <- generVois(np=np, nvois=2) 
# Comme tous les polys sont semblables, le flux est identique
# dans chacune des configurations: on peut se limiter  l'etude
# du carr central
poly <- matrix(poly[poly[,1]==15], ncol=2)
# Encore mieux: eliminer les configurations symtriques
# (flux en-dessus=flux au-dessus, flux a gauche=flux a droite, etc...)
poly <- matrix(c(rep(15,7), 1,2,3,7,8,9, 15), ncol=2)
#NB: le calcul des flux entre carrs latraux demande
# d'accroitre maxpts, pour que la convergence soit atteinte
# donc, calculer entre carrs l'un au-dessus de l'autre
# de prfrence  carrs l'un  ct de l'autre
# Cubature:
cub6x6.res <- califlopp(file="grille6x6.data",
                 param=list(verbose=FALSE,poly=poly,
 #                  maxpts=800000000,   
                   fun=1),
                 resfile="grille6x6.cub.res")


# Grid:
grid6x6.res <- califlopp(file="grille6x6.data",
                         param = list(method="grid", step=c(1,1),
                           nr=10, fun=1, output=1, poly=poly),
                         resfile="grille6x6.grid.res")
