\name{getRes}
\alias{getRes}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Read a result-file of CaliFloPP }
\description{
  Return the results stored on a file created by \code{CaliFloPP}
}
\usage{
getRes(ficres)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{ficres}{ pathname of a result-file of \code{CaliFloPP}.

    (In this version, the function can only read file in
    format "LIGHT" (see OUTPUT\_FILE\_FORMAT in src/caliconfig.h))}
}
\value{
  A list with as many components as pairs of polygons on the file.
  Each component is a list which contains:
  \item{poly }{Identifier of the pair of polygons. It is of pattern "poly1-poly2"
    where "poly1" and "poly2" are respectively the identifiers of the polygons.}
  \item{area }{Areas of the polygons in squared meters; vector of length
    2.}
  \item{n.eval}{Number of evaluations. It is a scalar, when  the method
    is "grid" or when there is only one dispersion function.
    It is a vector when the method is "cubature" and when there are
    several dispersion functions.} 
  \item{mean.flow, abs.err}{Only,
    when the method is "cubature". Integrated flow and
    absolute error, respectively;  vectors of length
    equal to the number of dispersion functions.}
  \item{conf.int}{Only,
    when the method is "cubature".
    Confidence interval; matrix with as many rows as
    dispersion functions, and columns "lower" and "upper".}
  \item{mean.flow, std}{Only,
    when the method is "grid".
    Mean of the integrated flows and standard
    deviation;  vectors of length
    equal to the number of dispersion functions.}
 When the method is "grid",
  the returned list contains also \code{step} and \code{nr}, the steps
  of the grid and the number of replications.
}
\references{ http://w3.jouy.inra.fr/unites/miaj/public/logiciels/califlopp/ }
\author{ A. Bouvier }
\note{ Details about the returned values can be found in the Reference
  Manual.
  }
  \seealso{  \code{\link{califlopp}}}
\keyword{ data }
