#ifndef _methodGrid_H
#define _methodGrid_H
/*--------------- COPYRIGHT ------------------------
| INRA - Unit MIA de Jouy en Josas                |
--------------------------------------------------*/

/*--------------- IDENTIFICATION PRODUIT -----------
| Derniere mise a jour : 28 aout 2007               |
| Role                 : la mthode par grilles    |
| Classe de base       :  methodIntegr             | 
--------------------------------------------------*/
/////////////////////////////////////////////////////////
#include "methodIntegr.h"
#include "Point.h"
#include <Rinternals.h>
/////////////////////////////////////////////////////////

class methodGrid:public methodIntegr
{

private:
  int est;
  unsigned int pseed;
  long nbeval;
  real h;
  real l;
  Boolean methcalcul[MAX_NFUNCTIONS];	// pour les heuristiques 
  real ep[MAX_NFUNCTIONS];
  real resultp[MAX_NFUNCTIONS][MAX_EST];	// les rsultats courants
  int nrepet[MAX_NFUNCTIONS];	// nbre de repet effectues

  /* Pour stocker les sommes de M */
  tPolygoni *sommeM;
  int *k;


public:
  ///////////////////////////////////////////////
  // Constructeurs
  ///////////////////////////////////////////////
    methodGrid ();

    methodGrid (const int nfunc, const int *ifunct);


    methodGrid (const int nfunc, const int *ifunct,
		const real *dz, const real *dp,
		const unsigned int pseed,
		const real l, const real h, const int est);


  ///////////////////////////////////////////////
  // Destructeur
  ///////////////////////////////////////////////
   ~methodGrid ();

  ///////////////////////////////////////////////
  // Mthodes d'accs
  ///////////////////////////////////////////////


  void
    getArgu (real & ah, real & al, int &aest,
	     unsigned int &aseed)
  {
      ah = this->h;
      al = this->l;
      aest = this->est;
      aseed = this->pseed;


  }


  ///////////////////////////////////////////////
  // Gestion des paramtres de la mthode
  ///////////////////////////////////////////////

  int ReadArgu ();
  int VerifArgu ();

  ///////////////////////////////////////////////
  // Impression des rsultats
  ///////////////////////////////////////////////
  void Print (const int poutput, const real areac, const real aread);

  void
    PrintFic (FILE * fp, const int noa, const int nob,
	      const double temps, 
	      const real areac, const real aread);

  ///////////////////////////////////////////////
  // Integration
  ///////////////////////////////////////////////
  void
    Integration (int *dispfc, Function * pfunction,
		 void ** dispf, void* env,
		 tPolygoni A, tPolygoni B,
		 int aii, int bii, real h, real l,
		 tPolygoni sommeM, int k, int nr,
		 long &nbptseval);

  ///////////////////////////////////////////////
  // Estimation
  ///////////////////////////////////////////////
  void
    CalcR (const int poutput, int *dispfc,
	   Function * pfunction,
	   void ** dispf, void* env,
	   const real areac, const real aread,
	   const real mindist, const Point lepoint,
	   const int numbera, const int numberb,
	   const int ac, const int ad,
	   const int nic[MAX_VERTICES],
	   const int nid[MAX_VERTICES],
	   tPolygoni * Polyc, tPolygoni * Polyd, 
	   double &temps);

};


//////////////////////////////////////////////////
#endif
