/*--------------- COPYRIGHT ------------------------
| INRA - Unité MIA de Jouy en Josas                |
--------------------------------------------------*/

/*--------------- IDENTIFICATION PRODUIT -----------
| Derniere mise a jour : 15 Jan 2006               |
| Role                 : programmes utilitaires    |
--------------------------------------------------*/
/////////////////////////////////////////////////////////
#include <iostream.h>
#include <math.h>
#include <float.h>
#include "util.h"
#include "calierror.h"
#include "calimacros.h"
#include "caliconfig.h"
#include "calidefs.h"



/////////////////////////////////////////////////////////////////
// Fonction de comparaison de reels  à Tolerance pres
/////////////////////////////////////////////////////////////////
// voir calidefs.h: TOL = REAL_MIN

Boolean
realequal (real a, real b, real Tolerance)
{
  if (fabs (a - b) < real (Tolerance))
    return True;
  else
    return False;
}

/////////////////////////////////////////////////////////////////
// Ecrire les messages d''erreur
// code: code négatif dont les valeurs valides sont dans erreur.h
//  mess: le texte à écrire
/////////////////////////////////////////////////////////////////



int
ecrmess (int code, char *moi, char *mess, Boolean fatal)
{

  //AB:??  if ((OUTPUT_WARNING != NOTHING) && (fatal == True))
  if (OUTPUT_WARNING != NOTHING)
    {
      printf("\n"); //  cerr << endl;
      if (code > 0)
	{
	  printf("Error %d\n", code); // cerr << "Error " << code;
	}
      if (strlen (moi) > 0)
	{
	  printf("(%s): ", moi); // cerr << "(" << moi << "): ";
	}
      printf("%s\n", mess); //cerr << mess << endl;
    }

  if (fatal == True)
    exit (code);
  else
    return (code);
}				/* fin ecrmess */

//////////////////////////////////////////////////////////
// Liberer la memoire
//////////////////////////////////////////////////////////
void
libMemPoly (int npoly,
	    int *a, int *numPoly, real * area,
	    int **ni, char **nomPoly, tPolygoni ** Poly, real ** bary)
{

  DETRU_T2 (bary, npoly);
  DETRU_T2 (Poly, npoly);
  DETRU_T2 (nomPoly, npoly);
  DETRU_T2 (ni, npoly);		// Pbe sur l'exemple Monnaz

  DETRU_T1 (area);
  DETRU_T1 (numPoly);
  DETRU_T1 (a);
}				// fin libMemPoly

////////////////////////////////////////
