# -----------------------------------------------------
# AB : 09/2/2006
# Fonction:
# Lecture du fichier des polys en format 1: 
# Argument:
# Le pathname du fichier qui contient les coordonnes des polys. 
# Retour:
# une liste de classe 'listpoly' dont chaque lment
# reprsente un polygone, celui-ci tant de classe 'poly'
# Des methodes existent pour ces classes: cf fichier 'methodes.R'
# -----------------------------------------------------
readpoly1 <- function(filename, delim=" ") {
# -----------------------------------------------------
  # Lecture de tout le fichier
  lu = readLines(filename)

  npoly = as.integer(lu[1])
#  cat("NPOLY:", npoly,"\n" )
  
  retour = list()
  
  k=1
  for (i in 1:npoly) {
    k=k+1
    # Lecture de l'identificateur, et abscisses
    ligne = strsplit(lu[k],delim)[[1]]
    ligne = ligne[ligne !=""]
    id = ligne[1]
    xlu =  as.double(ligne[2:length(ligne)])
    k=k+1
    # Lecture de l'identificateur, et ordonnes
    ligne = strsplit(lu[k],delim)[[1]]
    ligne = ligne[ligne !=""]
    if (ligne[1] != id) {
      stop(paste ("On the lines ", k-1, " and", k,
                  "the identifiers are respect. ", id,
                  " and", ligne[1], "\n"))
    }
    ylu =  as.double(ligne[2:length(ligne)])
    coo = matrix(c(xlu, ylu), ncol=2)
    dimnames(coo) = list(NULL, c("xcoord", "ycoord"))
    retour[[id]] = coo
  } # fin npoly
# Rajout de la classe et du call:
  class(retour) <- "listpoly"
  attr(retour, "call") <- match.call()
  return(retour)
}
