##################################################
# Dterminer si un objet de la classe Polygon est
# un poly convexe
#################################################
# #########################################################

if (!isGeneric("isConvex"))
	setGeneric("isConvex", function(x,verbose=FALSE, id="")
		standardGeneric("isConvex"))
# ____________________________________
# Cration de la dfinition par dfaut 'isConvex'
# ____________________________________
isConvex.default = function(x, verbose=FALSE, id="")
  {
  if (!inherits(x,"Polygon") && !inherits(x,"Polygons"))
    stop("This function is valid only on a 'Polygon' or 'Polygons' object.")

if (inherits(x,"Polygon"))
isConvex.Polygon(x, verbose, id)
else
isConvex.Polygons(x, verbose, id)
	
  }
# -----------------------------------------------


# ____________________________________
# Cration de la dfinition spcialise de 'isConvex'  Polygon
# ____________________________________
# id: identificateur  du poly  pour les messages
# Retour: T ou FALSE
# -------------------------------------------------------

isConvex.Polygon=
function(x,   verbose=FALSE, id="")
{
p1 = putClock.Polygon(x)


# Appeler le C 
# -------------
verbose=as.integer(verbose)
a = slot(p1, "coords")
# ter la fermeture du poly:
p2=matrix(NA, nrow=(nrow(a)-1), ncol=2)
for (i in 1:(nrow(a)-1))
 p2[i,]=a[i,]

 nia = as.integer(nrow(p2))
convex=0


ret = .C("isconvex",
    as.character(id),
     as.integer(verbose),
    as.double(p2),     as.integer(nia),
    convex = as.integer(convex),
NAOK=TRUE, PACKAGE="landm")

return(as.logical(ret$convex))

} # fin isConvex.Polygon

setMethod("isConvex", signature(x = "Polygon"),isConvex.Polygon)


# --------------------------------------------------
# Cration de la dfinition spcialise   Polygons
# ____________________________________
isConvex.Polygons=
  function(x, verbose=FALSE, id)
{
retour = rep(NA, nrow= length(slot(x, "Polygons")))

for (i in 1:length(slot(x, "Polygons")))
{
unpoly = slot(x, "Polygons")[[i]]
retour[i]= isConvex( unpoly, verbose, as.character(i))
}
return(retour)
} # fin isConvex.Polygons


setMethod("isConvex", 
		      signature(x = "Polygons", id = "missing"),
		      isConvex.Polygons)


