\name{inConvex.Polygon}
\alias{inConvex.Polygon}
\title{ Test the relative position of two convex polygons.}
\description{
 Test if a convex polygon is included, or contains, or cross,
or is distinct from another one.
}
\usage{
inConvex.Polygon(x, y, digits = 2, maxvertices = 50, notconvex)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{ An object of class \code{\link[sp]{Polygon-class}} }
  \item{y}{ An object of class \code{\link[sp]{Polygon-class}} }
  \item{digits}{ The number of decimal digits to take into account 
for the coordinates }
  \item{maxvertices}{ The maximal number of vertices per convex
  subpolygon }
  \item{notconvex}{ Convexity of either of both polygons.
 Logical. If TRUE, NA is returned. User should ignore this argument. }
}
\value{
A character equal to "D" (Distinct),
"I" (Included), "C" (Cross), or "S" (Surround)
whether y is distinct from, included in, cross,
contains x.

If \code{notconvex}=TRUE, NA is returned.
}
\references{ ~put references to the literature/web site here ~ }
\author{ A. Bouvier }
\seealso{ \code{\link{inConvex.Polygons}} }
\examples{
p1=Polygon(cbind(c(1,1,4,4,1), c(1,4,4,1,1)))
p2=Polygon(cbind(c(1.5,1.5,3,3,1.5), c(2,3,3,2,2)))
# Create a 'Polygons' to plot the two polygons on the same frame:
lp=Polygons(list(p1,p2),"")
plot(lp)
inConvex(p1,p2) #p2 is included in p1
inConvex(p2, p1) #p1 contains p2
}
\keyword{manip}
\keyword{methods}
