\name{readFormat1}
\alias{readFormat1}
\title{ Create an object of class Polygons of package sp from a file. }
\description{
Create an object of \code{\link[sp]{Polygons-class}} of package sp from coordinates read on a text file.
}
\usage{
readFormat1(filename, sep = " ", ID = filename)
}
\arguments{
  \item{filename}{ the name of the file which the data are to be read from. }
  \item{sep}{ the field separator character. Values on each line of
  the file are separated by this character. }
  \item{ID}{ value of the slot 'ID' in the created object. }
}
\details{
The file should contain:
- on the first line: the number of polygons,
- then, for each polygon, two lines:
  * an ident (an integer value), followed by the x-coordinates,
  * the same ident,  followed by the y-coordinates.
The coordinates should be clockwise if the polygon is not a hole,
and anticlockwise if it is a hole.
The polygon may be closed or not.
}
\value{
 An object of class \code{\link[sp]{Polygons-class} of package sp} 
}
\author{  A. Bouvier }
\seealso{  \code{\link{readFormat2}}}

\examples{
# not run
# Beginning of the file ex-data:
#66
#1 540139  540116 540261    540274
#1 1794900   1795000   1795000  1794920
#2  540378 540467 540453 540373 540374
#2  1795000 1795000 1794850 1794850 1794890
#
# > exdata= readFormat1("ex-data")

}
\keyword{IO}
\keyword{file}

