#ifndef _LESMACROS_H
#define _LESMACROS_H
/*--------------- COPYRIGHT ------------------------
| INRA - Unit MIA de Jouy en Josas                |
--------------------------------------------------*/

///////////////////////////////////////////////////////

#include <stdio.h>
#include <float.h>
#include <stdlib.h>

////////////////////////////////////////////////////
// Les macros
////////////////////////////////////////////////

////////////////////////////////////////////////
/* ............ Fonctions MIN, MAX  ........................*/
////////////////////////////////////////////////
#define MIN(a,b) ( (a)<(b) ? (a) : (b))
#define MAX(a,b) ( (a)>(b) ? (a) : (b))


// NOTE: ne pas utiliser R_alloc car on a besoin
// de desallouer les elts crs avec la macro
// NEW (cf les 'free')
#define NEW(p, type)\
  if ((p=(type *) malloc (sizeof(type)))==NULL) {\
  printf ("NEW: Out of Memory!\n");\
  exit(EXIT_FAILURE);\
}



#define ADD(head, p) if(head){\
  p->prev = head;\
  p->next = head->next;\
  head->next = p;\
  p->next->prev = p;\
}\
else {\
  head = p;\
  head->next = head->prev = p;\
}
#endif
