# ####################################################
# Package landm: tests
# ####################################################
# Either:
 library(landm)
# or:
# ### 
# ### library(sp)
# ### # Source des fonctions
# ### # --------------------
# ### source("../R/Class-ConvexPolygon.R")
# ### source("../R/putClock.R")
# ### source("../R/readFormat1.R")
# ### source("../R/readFormat2.R")
# ### source("../R/crConvex.R")
# ### source("../R/nConvex.R")
# ### source("../R/isConvex.R")
# ### source("../R/inConvex.R")
# ### source("../R/distMin.R")
# ### source("../R/plot.R")
# ### source("../R/select.R")
# ### # Source des programmes:
# ### # --------------------
# ### # (sera fait automatiquement, quand le package sera fait)
# ### dyn.load("../src/landm.so")
# ####################################################
# ------------------------------------
# The function execute on a Polygons
execute.Polygons = function(x)
{
plot(x)
cat("inConvex\n")
print(inConvex(x))
cat("distMin\n")
print( distMin(x))

if (any(!isConvex(x)))
{
   d=crConvex(x,  plot=T)
   cat("nConvex", nConvex(d), "\n")
   plot(d)
   cat("distMin\n")
   print( distMin(d))
}
} # fin execute.Polygons

# ------------------------------------
# The function execute on 2 Polygon
execute.Polygon= function(p1, p2)
{
x=Polygons(list(p1,p2), "test")
execute.Polygons(x)
}

# ------------------------------------
# The tests:
# ------------------------------------
cat(" Distinct polygons\n")
p1= Polygon(cbind(c(5,6,6,5,5), c(4,4,3,3,4)))
p2= Polygon(cbind(c(2,1,4,4,2), c(2,4,5,3,2)))
execute.Polygon(p1,p2)

cat(" p2 is a hole equal to p1\n")
p2=Polygon(cbind(rev(c(5,6,6,5,5)), rev(c(4,4,3,3,4))))
execute.Polygon(p1,p2)

cat(" p2 and p1 are distinct, and p2 is non convex\n")
p2 =  Polygon(cbind(c(276, 280, 158, 153, 249, 274, 276),
c( 851, 801, 821, 841, 871, 891, 851)))
execute.Polygon(p1,p2)
d=crConvex(p2)
plot(d)
plot(d[1], add=T, col="red")
isConvex(d[1])

cat(" A real example in format1: ex-data ( LONG)\n")
exdata= readFormat1("ex-data")
plot(exdata)
plot(exdata[4], add=T, col="red")
d=distMin(exdata)
isConvex(exdata[3])
cat (" From ex-data: a convex polygon and a non-convex one\n")
execute.Polygon(exdata[3], exdata[4])
cat(" ex-data: creation of all the convex polygons\n")
d=crConvex(exdata, verbose=T)

cat ("Part of ex-data where a hole has been added: ex-small\n")
exsmall=readFormat1("ex-small")
execute.Polygons(exsmall)


cat(" A real example in format2: ex-nc\n")
exnc= readFormat2("ex-nc")
cat(" All polygons of ex-n are convex\n")
print(isConvex(exnc))
plot(exnc)
execute.Polygon(exnc[54], exnc[55])
execute.Polygon(exnc[44], exnc[58])

cat(" A real example in format2: ex-parc. \n")
exparc=readFormat2("ex-parc")
d=crConvex(exparc, verbose=T, plot=T)

cat(" Another  real example in format2: Parc1.prn\n")
exParc1=readFormat2("Parc1.prn")
d=crConvex(exParc1, verbose=T, digits=2)

cat (" p2 is a hole in p1\n")
p1=Polygon(cbind(c(1,1,4,4,1),c(1,4,4,1,1)))
p2=Polygon(cbind(c(2,3,3,2,2), c(2,2,3,3,2)))
execute.Polygon(p1,p2)

cat (" p2 is included in p1 and p2 is non convex\n")
p1=Polygon(cbind(c(1,1,5,5,1), c(1,5,5,1,1)))
p2=Polygon(cbind(c(2,4,2,3,2),c(2,3,4,3,2)))
execute.Polygon(p1,p2)


cat (" p1 and p2 have a common side\n")
p1=Polygon(cbind(c(1,1,2,2,1), c(1,2,2,1,1)))
p2=Polygon(cbind(c(2,2,3,3,2), c(1,2,2,1,1)))
execute.Polygon(p1,p2)

cat (" p1 and p2 are jointed\n")
p2=Polygon(cbind(c(2,2,3,3,2), c(1,2.5,2.5,1,1)))
execute.Polygon(p1,p2)

cat (" Intersection not null between the 2 polys\np2 have real coordinates\n")
p1=Polygon(cbind(c(1,1,2,2,1), c(1,2,2,1,1)))
p2=Polygon(cbind(c(1.5,1.5,3,3,1.5), c(1,2,2,1,1)))
execute.Polygon(p1,p2)

cat (" p2 is included in p1 and have real coordinates\n")
p1=Polygon(cbind(c(1,1,4,4,1), c(1,4,4,1,1)))
p2=Polygon(cbind(c(1.5,1.5,3,3,1.5), c(2,3,3,2,2)))
execute.Polygon(p1,p2)

cat (" Intersection not null between the 2 polys\n")
p1=Polygon(cbind(c(1,1,3,1), c(1,2,2,1)))
p2=Polygon(cbind(c(2,2,4,4,2), c(1,3,3,1,1)))
execute.Polygon(p1,p2)


cat (" A polygon which intersects itself\n")
inter=Polygon(cbind(c(1,6,6,2,1,5,3,4,1,1), c(1,1,4,5,4,2,2,3,3,1)))
plot(inter)
linter =Polygons(list(inter), "II")
d=crConvex(inter, plot=T)
plot(d[1], add=T, col="green")
plot(d[2], add=T, col="blue")
plot(d[3], add=T, col="maroon")
plot(d[4], add=T, col="orange")
distMin(d)

